import Zope
import unittest

import FunctionalTests
from FunctionalTests.ConfigParserExt import *

from Globals import package_home
import os, string

class CPETests( unittest.TestCase ):

    def setUp( self ):
        pass

    def tearDown( self ):
        pass

    def test_empty( self ):

        empty = ConfigParserExt()

        assert empty.listSpecialSections() == ( 'DEFAULT', )
        assert not empty.listOtherSections()

    def test_withFile( self ):

        cpe = ConfigParserExt( ( 'Header', 'DEFAULT' ) )

        assert len( cpe.listSpecialSections() ) == 2
        assert 'Header' in cpe.listSpecialSections()
        assert 'DEFAULT' in cpe.listSpecialSections()
        assert not cpe.listOtherSections()

        FT_path = package_home( FunctionalTests.functest_globals )
        filename = os.path.join( FT_path, 'tests', 'config.ini' )
        cpe.read( filename )

        assert len( cpe.listOtherSections() ) == 5

        for i in range( 6 )[1:]:
            section = 'Section_%d' % i
            assert section in cpe.listOtherSections()
            self.assertEquals( cpe.get( section, 'key' )
                             , string.lower( section ) )

    #
    #   2.4 unittest has these.
    #
    if not hasattr( unittest.TestCase, 'assertEquals' ):
        def assertEquals( self, lhs, rhs ):
            assert lhs == rhs, '%s == %s' % (lhs, rhs )

def test_suite():
    return unittest.makeSuite( CPETests )

def run():
    unittest.TextTestRunner().run(test_suite())

if __name__ == '__main__':
    run()
